v1.0.10.1 (2017/11/24)
======================
The save data format didn't seem to change with Fire Pro World v0.9500,
but some new moves were added to the game.
Guess that means the Save Tool needs to be updated.

You might be thinking, "freem, you said you weren't going to try tracking the
Early Access updates in the last version's changelog!"

Well... the save format didn't change, AND since I had already automated the
process of extracting the move list for updates... there's no real reason to
artifically hold back a release.

Just, uh... Don't expect much more than that in this update.

* [General] Support for game version v0.9500.
  As mentioned above, the save data version number did not change, so it's
  still at 5.

* [Internal Move List] Updated move list to v0.9500.

* [AuthorDB, ItemAuthors] Tiny database update.
  Author Count: 199  -> 205  (+6)
  Item Count:   6835 -> 6850 (+15)

v1.0.10.0 (2017/11/15)
======================
As mentioned in the changelog for v1.0.9.2, this version of the Save Tool will
be the last release where I attempt to keep up with the game updates during
the Early Access period. Releases will still happen, but at a slower pace.

* [General] Support for game version v0.9012.
  The save data version number did not change, remaining at 5.
  (This is despite the changes made to Priority settings.)

* [CPULogic class] Fixed issue related to priority slot changes made in
  Save Tool v1.0.9.2. (Thanks to Deranged-Stu for reporting this bug.)
  (This fixes the wrestler importing bug mentioned on twitter.)

* [Main form] Added Options menu, Program Options dialog, and Game DLL
  Information dialog.

* [CPU Logic dialog] Added support for displaying new priority positions.
  (Currently untested.)

* [Edit Wrestler dialog, Japanese translation only] Fixed SHA256 Hash button
  not displaying its entire text.

* [Edit Wrestler dialog] Changed accelerator for "Wrestler List" menu item from
  'L' (also used for CPU Logic) to 'T' (was not being used until now).

* [Main form] Updated the Wrestler Count line in the information dump to show
  the number of local and workshop (subscribed) wrestlers.

* [Main form] Added Published Ring Textures count to the Workshop section of
  the information dump.

* [Main form] Added number of Subscribed Wrestlers, Referees, and Ring Textures
  to the Workshop section of the information dump.

* [Main form] Added Control+S shortcut for saving changes.

* [AuthorDB, ItemAuthors] Tiny database update.
  Author Count: 199  -> 199  (no change)
  Item Count:   6829 -> 6835 (+6)

v1.0.9.2 (2017/11/10)
=====================
Another bugfix release with some (small) new features and some backend work for
future versions.

There are some things that need to be addressed with this release, however.

1) Wrestler Deletion
--------------------
This release sadly marks the removal of the wrestler deletion feature,
meaning the "Carlzilla was right" counter is increased to 4 or 5 (depending on
how you keep count).

Evil Jerk (from the Steam forums) has given me a decent amount of information
to go on regarding the problems with the wrestler deletion process, so it's
possible the feature will eventually return. However, it won't be for a while,
as a lot of testing is required to ensure it doesn't screw things up for
everyone (again).

I don't have a timeframe for this, but I can say it won't be in the initial
release of v1.0.10.0 (for game version 0.9012).

Given the next point, it might not even be re-added in the v1.0.10.x series...


2) Reduced Pace for Future Releases
-----------------------------------
Also, this release marks a point where I must address something.
Development of the save tool and attempting to deal with the issues it brings
(a.k.a. having to play tech support on top of developing the program) is taking
a toll on my mental health (which, to be honest, isn't in very good shape to
begin with). You may have noticed this, or you may not have. Either way...

I've been advised by multiple people to take things slower, and to not deal with
everything as immediately urgent. Despite not wanting to take this advice, I am
forced to, lest I end up in the hospital with a heart attack or something.

Save Tool v1.0.10.0 is still somewhat on schedule, depending on what changes the
developers bring with game version 0.9012. It will likely be the last release
where I attempt to react with immediacy towards game updates during the Early
Access period.

Bugfix versions of the Save Tool will also suffer under this new setup, but
to be honest, they are the reason behind this message in the changelog.

I want to send a general note of appreciation to those who have reported bugs.
I'm not saying "don't report bugs", and I don't really know of a simple way to
put into words what I really feel here.

Maybe it has something to do with bugs in code that's my own bespoke creation
(e.g. costume exports) vs. attempting to re-implement the various game
structures and their special cases (e.g. deleting wrestlers, setting custom
theme music) vs. issues that really need to be fixed in the Returns Wrestler Tool.

I'm not fully sure.


3) Notes on tech support-related comments on Twitter made during the release of
a previous version of the Save Tool
-------------------------------------------------------------------------------
(Wordy title, I know.)

I clearly didn't completely think when making these statements, and I apologize.
They were only meant towards those whose primary native language is English.

Since those tweets, someone has offered to translate the Save Tool's manual
into Japanese. I have no timeframe as to when the Japanese documentation will
be complete, nor do I wish to rush the person working on it, as they likely
have a lot of other things going on in their life.

I am not aware of anyone having contacted me for performing a Japanese
translation of the Fire Pro Returns Wrestler Tool, though, so that manual will
only be available in English for the time being. My apologies for that.

Please get in touch with me if you are willing to translate the Returns Wrestler
Tool manual.


The actual dang changelog
-------------------------
* [Workshop dialog] Fixed issue related to clicking in an empty spot on all of
  the item lists.

* [Workshop dialog] Removed Subscription Manager and the ability to delete data,
  because it was causing too many issues.
  (Please see Note #1 above for more information.)

* [Edit Wrestler dialog] Removed the ability to delete wrestlers, because it was
  causing too many issues.
  (Please see Note #1 above for more information.)

* [CostumeData class] Fix body part scale issues when importing older
  appearance data (with only five scale values).
  (Thanks to Evil Jerk for reporting this bug.)

* [CPULogic class] Added code to handle priority slots 4-10 when loading older
  CPU Logic data (with only three priority slots).

* [OptionSettings class] Added code to set sensible defaults for newer options
  when loading older savedata.

* [Edit Ring dialog] When creating a new ring, give the ring a proper date,
  instead of 0000/00/00 00:00.

* [General] Added (invisible) options for remembering the last directories used
  for loading save data, importing/exporting appearance data, importing/exporting
  ring data, and importing .fpwedit files.

  These options default to the Save Tool's directory and are changed by loading
  or saving a file in the respective Load/Save dialog. (Dragging and dropping
  the savedata file onto the main window does not change the saved directory
  for savedata files.)

  These options may become visible when the Program Options dialog is completed.

* [AuthorDB, ItemAuthors] Another small database update.
  Author Count: 197  -> 199  (+2)
  Item Count:   6814 -> 6829 (+15)

* [General] Backend work on interesting things for a future version. Parts of
  this may appear in v1.0.10.0, or they might make their debut later than that.

  (Sadly, this is not the "Edit Analyzer" I referred to in a list of things I'd
  like to implement in the Save Tool...)

* [Edit Wrestler dialog] Added the ability to export a list of wrestlers in the
  save data, sorted in one of two ways:
  1) Internal Wrestler ID (includes edit wrestlers only)
  2) Sorted by Organization and Group (includes both edit and preset wrestlers)

* [Wrestler Skills dialog] Change custom theme music filename field to read-only,
  because apparently it's not working. There have also been reports that the
  custom music numerical value (read: the one in the dropdown box that I thought
  I fixed in v1.0.9.1) is different from what I've experienced, so I honestly
  don't know.

  If you want to give a wrestler custom theme music, do it in the game.
  If they're a Workshop wrestler, clone them first.

  I'm sorry, but if setting a custom theme doesn't actually work in the save
  tool, then I have no incentive to let people edit the filename, *especially*
  if they are trying to do something that the game just won't work with.

  I can not possibly fix shortcomings related to the game's custom music
  directory issues with a mere external tool.

  It's not worth dealing with the tech support requests to keep this feature
  in its current state.

v1.0.9.1 (2017/11/03)
=====================
Small (but important) bugfix release for v1.0.9.0.

* [Wrestler Skills dialog] Fixed issue related to assigning custom themes to
  wrestlers. (Thanks to sonny615 for reporting this bug.)

* [AuthorDB, ItemAuthors] Small database update.
  Author Count: 196  -> 197  (+1)
  Item Count:   6801 -> 6814 (+13)

v1.0.9.0 (2017/11/01)
=====================
Fire Pro World v0.9011 brings more changes to the save data structures.
Probably the worst time for my primary development computer to die.

* [General] Support for game version v0.9011/save version 5.

* [Workshop dialog] Added ability to copy Steam Workshop links via a right
  click context menu.

* [Workshop dialog] Added Subscribed Ring Items tab.

* [Workshop dialog] Added Sub Item ID entry to all tabs, though only Ring Items
  use non-zero values for now.

* [Edit Ring dialog] Added the two new texture filename entries and updated the
  labels of all custom textures. Entries are still read-only for the time being.

* [AuthorDB, ItemAuthors] Another database update.
  Author Count: 188  -> 196  (+8)
  Item Count:   6733 -> 6801 (+68)

* [Appearance dialog] Fixed issue where clipboard color would not persist between
  different characters. (Thanks to Norm Rhodes for reporting this bug.)

* [Edit Ring dialog] Remove "Custom Texture Fix" option, as the official custom
  ring texture support does not use it.

* [Match Options dialog, Title Match Options dialog] Changed "Entrance BGM"
  option title to "Entrance Style" and added value descriptions.

* [Skills dialog] Fixed an issue relating to Voice ID values greater than the
  maximum possible value. A message box will show up containing the problematic
  values and a note that they've been set to 0. (Apologies to Dawnbreaker, whom
  I told to fix incorrect voice assignments from Returns ports using the tool...
  Until I fixed this issue, you couldn't. Oops.)

* [General] Attempt to idiot-proof the program slightly with regards to certain
  features. Please read the manual to avoid possible issues with the program.

* [General] Various internal fixes that aren't immediately visible to people not
  named "freem".

* [SHA256 Hashes dialog] Updated checks for default "Build from Blank" values.
  Affected hashes include Moveset (Full), Moveset (Moves Only), and CPU Logic.

v1.0.8.1 (2017/10/27)
=====================
This is primarily a bugfix release for v1.0.8.0, but a few new things snuck in.

* [Returns to World Import] Fixed an issue where voices were not importing
  properly. (Thanks to DawnBreaker/ControlFrenzy for reporting this issue.)

* [Appearance dialog] Fixed issue where not all color panels had the context menu.

* [Appearance dialog] Added the ability to edit highlight values in steps of 0.01.

* [Find Wrestler dialog] Double clicking on an entry in the list now acts the
  same as selecting an entry and pressing the "OK" button.

* [Appearance Import/Export Format] Fixed a bug related to loading the new
  version of the costume export data.
  (Thanks to @mob_gao for reporting this issue.)

* [Tournament/League Progress] Progress dialog split out into separate
  Tournament and League Progress dialogs.

* [Tournament/League Progress dialogs] If a title is being contested, the name
  of the title can be clicked on to view it in the Title dialog.

* [Tournament Progress dialog] Double clicking a slot entry in the Matches tab
  will view that team's entry in the Participants tab.

* [League Progress dialog] Implemented Participants tab view.

* [League Progress dialog] Implemented rough-draft of Scores tab view.

v1.0.8.0 (2017/10/15)
=====================
A new Fire Pro World update means an update to the Save Tool.

* [General] Support for game version v0.9010/save version 4.

* [Options dialog] Added Crowd Volume setting. Also split dialog into Main
  and Sound sections.

* [Internal Move List] Updated move list to v0.9010.

* [Appearance dialog] Changed body part scale range to 0%-200%. This solves
  the problem with "Pinhead" Mike dg (and other characters with non-standard
  scale values), but I honestly did not expect this to be officially supported.

* [Returns to World Import] Handle v0.9010 scale changes.

* [Main form] Added Game Version next to Save Version in the information dump.

* [Appearance dialog] Body Part Scale now uses 9 boxes.
  Unlike most dialogs in this program, the Appearance dialog does not change based
  on the save version. It's too complicated to deal with both scale modes.

* [Wrestler Order dialog] Implement "View in Wrestler Dialog" button for Group sort.

* [Appearance dialog] Body Part Scale boxes now change color based on values.

* [CPU Logic dialog] Added Priority slots 4 to 10.
  Unlike most dialogs in this program, the CPU Logic dialog does not change based
  on the save version. It's too complicated to deal with two different list types.

* [Options dialog (Japanese/日本語)] Renamed sound options to match game names.
  (I personally think "音量" should be used instead of "ボリューム", but being
  consistent with the game is probably better.)

* [CPU Logic dialog (Japanese/日本語)] Removed duplicate list items.

* [SHA256 Hash dialog] Changed hash functions to use the latest version of the
  Logic and Appearance data.

* [Appearance Import/Export] Updated .fpwapx format to handle the new costume
  data format. The program will attempt to read costume exports from older
  program versions, but I cannot guarantee it will work properly for every
  possible edge case.

* [Appearance Import/Export] Updated rcos/wcos/xcos format to handle the new
  costume data format. Unlike .fpwapx, there is no simple way to determine which
  version of the costume data is included.

* [Returns to World Import] Attempt to convert voice types from Returns to World.
  A notification is displayed if an imported wrestler uses a voice removed in
  Fire Pro World.

* [Wrestler Skills dialog, Referee dialog] Added new Voice Type options.

* [Wrestler Skills dialog] Voice 2 Type combo box changed to drop down list.

* [Wrestler Skills dialog, Referee dialog] Disabled new Voice Type options when
  loading an older savedata version.

* [Workshop dialog, Subscription Manager dialog] Disabled "Delete Local
  Subscription Only" feature due to some reported bugs. This may be re-enabled
  in a later version.

* [Options dialog] Fixed Tab key ordering to match new layout.

* [Edit Ring dialog] Fix issue where selecting new mat types and corner pad
  types didn't actually update anything in the save data.

* [Appearance dialog] Changing body size and stance now updates appearance data.

* [Appearance dialog] Copying and pasting colors implemented.

* [Title dialog] Copying and pasting colors implemented. Not exactly the most
  useful thing considering there's only two colors, but...

* [Default Wrestler Names] Fixed "Bood" Angel typo.

* [Default Wrestler Names] Added Japanese names. The displayed wrestler name
  depends on the Language set in the game options.

* [Wrestler Display Order dialog] Added the ability to re-sort the list in
  multiple ways:
  * Alphabetical (still could use some work, IMO)
  * Edit Points (Ascending) (0 to 380)
  * Edit Points (Descending) (380 to 0)
  * Organization/Group order
  * Wrestler ID

* [Wrestler Display Order dialog] Fixed issue where the list wouldn't be updated
  if wrestlers were deleted after going to the Edit Wrestler dialog via "View in
  Wrestler Dialog" button.

v1.0.7.2 (2017/10/10)
=====================
Primarily a bugfix release for v1.0.7.1.

* [Returns to World Import] Added Beads chest layer to the Returns -> World
  costume conversion map. (Thanks to JamUpGuy for reporting this issue.)

* [Returns to World Import] Added Bow Tie chest layer to the Returns -> World
  costume conversion map.

* [AuthorDB, ItemAuthors] The biggest update to the internal database so far.
  Author Count: 81   -> 188  (+107)
  Item Count:   1197 -> 6733 (+5536)
  As of this writing, the Workshop has 19,325 items published.
  The database now has entries for around 33% of the items on the Workshop.
  (The math says around 34%, but there are items that have been taken off of
  the Workshop included in the database, so it's not fully accurate.)

* [General] Added program icon.

v1.0.7.1 (2017/10/08)
=====================
Bugfix release for v1.0.7.0, caused by wanting to get this program released as
soon as possible, instead of waiting for bug reports from the testers. Oops.

This release also contains Japanese translations for various dialogs and forms.
I don't know if the quality is good for some translations... Some strings have
been taken from the game; those should be fine.

* [Returns to World Import] Fixed ordering of Kung Fu shoe layers.

* [Returns to World Import] Implemented body part scale conversion.

* [Edit Wrestler dialog] Hopefully fixed issue involving cloned wrestlers and
  the cache feature. This fix does not apply to wrestlers who were already
  cloned, only newly cloned wrestlers.

* [CPU Logic dialog] Fixed order of entries in "Dazed Standing" section.
  (Thanks to @mob_gao for reporting this issue.)

* [Returns to World Import] Fixed issue relating to importing Dazed Standing
  CPU Logic where the values for (BIG) and (BIG)+Direction were swapped.
  (Thanks to JamUpGuy for reporting this issue.)

* [General] Various forms had their elements translated to Japanese. Not every
  form is complete, but the following forms/dialogs have been either translated
  or updated:
  * Add Organizations/Groups dialog
  * Match Options dialog, Title Match Options dialog (most option titles and values)
  * Online Records dialog
  * Main Form: Renamed "団体やチーム" to the arguably more correct "団体と軍団".
  * (Game) Options dialog: Translated "Wrestler Cache" entry to Japanese.
  * Organizations/Groups dialog
  * Move Names dialog
  * Workshop Item Database
  * Author Database dialog
  * Main Form: All remaining untranslated form elements translated to Japanese.
    Most of the information dump (large text box) contents are translated, but
    there are a few remaining items still in English.
  * Edit Referee dialog
  * Title dialog
  * Edit Wrestler dialog
  * Wrestler Display Order dialog
  * Appearance dialog
  * Mass Wrestler Import dialog
  * Single Wrestler Import dialog
  * Import Appearance from Fire Pro Returns Wrestler Edit dialog
  * (regular) Import Appearance dialog
  * Edit Ring dialog
  * Wrestler Skills dialog
  * Wrestler Moveset dialog
  * CPU Logic dialog
  * Move Slot name list

  It is important to note that the Japanese translation is still not considered
  complete, but it's in a much better position than it was in v1.0.7.0.

* [Workshop dialog] Added text limits for item title (128 characters),
  description, and change notes (both have a limit of 8000 characters).

* [CPU Logic dialog] Added Fight Style to Run Evasion Technique mappings.

* [Workshop dialog] Made dialog wider so Japanese language version of "Workshop
  Page" label wouldn't be split on two lines.

* [Online Records dialog] Enabled in public version.

* [CPU Logic dialog] Fix one of the "Down Near Center" category entries from
  "Run to Corner LRG" to "Run to Downed Opponent (LRG)".

* [Move Wrestler dialog] Special case the "Retired" organization and group name
  in the destination drop down box.

v1.0.7.0 (2017/10/02)
=====================
This is the first release to the general public, after about 2+ months of
development and testing. Not everything is considered "complete", but
implementing the remaining features would delay this program's release even
longer.

* [AuthorDB, ItemAuthors] Another database update.
  Author Count: 73  -> 81   (+8)
  Item Count:   959 -> 1197 (+238)

* [General] More conversion of hard-coded strings to Resources for localization
  purposes.

* [Orgs/Groups dialog] Disabled the Delete button when selecting the Retired group.

* [Parameters dialog] Fixed two Defense labels:
  "Flying" -> "Aerial"
  "Pounding" -> "Impact"

* [General] Various forms translated into Japanese. Overall program translation
  is still not complete, however.

* [Swap Costumes dialog] Add keyboard accelerators for Costume Swap 1 and 2.

* [Subscription Manager dialog] Added keyboard accelerators for the Wrestler
  list ('W') and Referee list ('R').

release candidate 2 - 2017/09/30 (v1.0.6.1)
===========================================
* [Returns to World Import] Added missing "Western" item to Shins item list.
  Fixes issue where all Shin items after "Mexican" were off by one.

* [General] Started converting various hard-coded strings to use Resources,
  making translations to other languages easier.

release candidate 1 - 2017/09/29 (v1.0.6.0)
===========================================
With this release, the testing period is drawing to a close. If there are no
serious issues remaining, this is probably going to be the first public release.

* [Match Options dialog] Enabled in public version, though still read-only.

* [Edit Rings dialog] Added read-only support for the three string values added
  to the edit ring data structure in game version 0.9008. I'm pretty sure the
  game doesn't use them yet, that's why they're read-only.

* [Import Appearance dialog] Fix issue related to importing costumes in "invalid"
  slots. (e.g. Importing a costume into slot 4, when the wrestler only has
  costumes slots in 1 and 2.) However, this fix has an issue related to slot
  assignment when importing all costumes in a non-sequential order...

* [Import Appearance dialog] Added "Swap Costumes" button, allowing you to swap
  the ordering of costumes. (Useful when your imports don't go as planned due
  to the above bugfix...)

* [General] If the local copy of the manual is missing, the program will ask if
  you want to view the online version of the manual.

* [Internal Move List] Updated move list to v0.9009.

* [CPU Logic] Added wrestler name to form title.

* [Returns to World Import] Enabled Strike Exchange on imported wrestlers.

* [Workshop Information dialog] Fixed issues related to deleting local wrestler
  and referee data. (The fix from v1.0.5.1 didn't get copied over to the Workshop
  dialog...)
  "Carlzilla was right (to not allow deleting wrestlers)" counter is now at 3.

* [AuthorDB, ItemAuthors] Another database update.
  Author Count: 45  -> 73  (+28)
  Item Count:   409 -> 959 (+550)

* [Progress dialog] Decoded Control values for Tournament participants.

* [Workshop Information dialog] Subscribed Wrestler and Referee Title textboxes
  set to read-only, since the changes don't get saved.

* [Workshop Item Database dialog] Implemented "Add Item" feature, allowing you
  to add entries to the Item Author database without requiring the wrestler or
  referee to be installed/in your save data.

* [Set Subscribed Item Author dialog, Add Workshop Item dialog] Widended the
  author list drop down box to fit longer names.

* [General] Implemented maximum string lengths on various items. This includes:
  * Referee Names: 50 characters
  * Wrestler First/Short Names: 25 characters
  * Wrestler Last/Long Names: 50 characters
  * Wrestler Name Separator: 2 characters (may increase to 5 later; enough for " the ")
  * Wrestler Nickname: 50 characters
  * Org/Group Long Names: 50 characters
  * Org/Group Short Names: 25 characters
  * Ring Names: 50 characters
  * Belt Names: 50 characters
  * Finisher Name: 50 characters

* [Orgs/Groups dialog] Fixed bug involving group display order not being updated
  when moving organizations, leading to in-game issues in various Edit Mode menus.

* [Wrestler Profile dialog] Re-labeled Short and Long Name to include the "First"
  and "Last" labels given in game.

* [Orgs/Groups dialog] Added a hacky insertion line to help determine where the
  organization or group will end up. I'd like to develop a better solution (or
  use a more robust custom TreeView control) before expanding this to the Wrestler
  Display Order dialog.

* [Edit Wrestler dialog] Added information for Published wrestlers.

* [Default Appearance Data] Added default costume data to costume slots 2-4.
  These slots were previously uninitialized, which could cause issues in game.

* [Returns to World Import] Import most costume parts?? Needs more testing.
  Head layers (non-base) are not imported at the moment.

* [Appearance dialog] Added .fpwedit to list of options for costume importing.

preview release 2017/09/23 (v1.0.5.2)
=====================================
Very important bugfix release for v1.0.5.1.

* [Returns to World Import] Fix an issue with Priority action import that would
  cause the game to lock up when editing CPU Logic.
  (Thanks to Carlzilla for reporting this bug.)

* [File Saving] Close the MemoryStream after saving. This may or may not
  fix a certain crash issue (that I have not been able to replicate).

* [Match Options dialog] Added decoding for the following options:
  * Format/Match Type
  * "Settle1" and "Settle2"
  * Match Time
  * Match Count
  * Explosion Time
  * Round Count
  * TKO Count
  * Corner Weapon
  * (League) Point Type
  * (League) Block Count
  * (League) Tournament Final Match
  * Match BGM
  These changes apply to the Title Match Options dialog as well.

* [Match Options dialog] Selected the first entry in each dropdown box by default.

preview release 2017/09/20 (v1.0.5.1)
=====================================
Bugfix release for v1.0.5.0; only really "big" thing is Mass Wrestler Import.
Everything else is either bugfixing or quality of life improvements.

* [Returns to World Import] Fix issues with the biography text of some wrestlers.

* [Returns to World Import] Might have fixed issues related to Finisher Name...

* [Returns to World Import] Allow import of multiple .fpwedit files at once.

* [Wrestler Moveset dialog] Disable sorting columns.

* [Edit Wrestler dialog] Fixed issue with Clone button where wrestlers would be
  added to the display order multiple times.
  (Thanks to DakotaK for reporting this bug.)

* [Edit Wrestler dialog] Deleting a subscribed workshop wrestler now removes
  the local subscription information and fixes various wrestler IDs.
  (Thanks to Phil Parent for reporting this bug.)

* [Main Form] Added savedata drag and drop support.

* [Wrestler Order dialog] Enabled dialog resizing.

* [Edit Referee dialog] Fixed a workshop referee deletion issue.
  (Similar to the fix for deleting wrestlers.)

* [General] Implemented support for opening save files via command line argument.
  (This also works by dragging a save file onto the program's icon.)

preview release 2017/09/17 (v1.0.5.0)
=====================================
* [General] Support for game version v0.9008/save version 3.

* [Changelog] New changelog entry format. Slightly messier, but better for
  chronological and out-of-order changes. (Some exceptions still remain, such
  as announcing support for new game/save versions.)

* [CPU Logic dialog] Fixed bug related to Priority move slot "None".

* [Referee dialog] Finally removed JSON export button in private version.

* [Main form] Removed "Preset Wrestler Groups" option that I was never going to
  code anyways.

* [Chunk Browser] Removed Chunk Browser (was only in private version).

* [Achievements dialog] Color-coded cells in "Unlocked" column based on status.

* [Missions dialog] Color-coded cells in Status column.

* [Ring dialog] Fixed date/time display not using leading 0s when necessary.

* [Match Options dialog, Title Match Options dialog] Started decoding match
  option values.

* [Orgs/Groups dialog, Move Wrestlers sub-dialog] Added author name to
  workshop wrestlers (when identity is known).

* [AuthorDB, ItemAuthors] "Massive" database update.
  Author Count: 41  -> 45  (+4)
  Item Count:   108 -> 409 (+301)

* [Set Subscribed Item Author dialog] Add/change keyboard accelerators.
  ("Add New Author" now uses 'N' instead of 'A';
  "Existing Authors" uses 'A' instead.)

* [Set Subscribed Item Author dialog] Allow use of Enter for OK, Escape for Cancel.

* [Add Author dialog] Added keyboard accelerators for "Steam ID" ('I') and
  "Author Name" ('N').

* [Change Author dialog] Choosing "unknown author" removes entry if it exists
  (allowing you to "properly" fix mistakes; don't ask me how I know).

* [Workshop Information dialog] Made Description and Change Notes on Published
  Items tab read-only (they didn't change any data if they were edited anyways;
  editing support may be added in a future version).

* [Orgs/Groups dialog] Retired org/group name is now special cased in the
  treeview, for people who are afraid of Japanese text for some reason.
  The Short and Long Name textboxes still display the original values from
  the save file, though. This is intentional.

* [Achievements dialog, Missions dialog] Enabled in public version, despite
  being read-only.

* [Edit Wrestler dialog] Workshop author name is now shown before Steam ID.

* [Find Wrestler dialog] Added author name to workshop wrestlers (when identity
  is known).

* [Move Slot Names] Fixed issue where "Triple Team Front Grapple" would appear
  instead of "Triple Team Corner Grapple".

/!\ IMPORTANT FEATURE ALERT /!\
* [Edit Wrestler dialog] Enabled Import button; allows importing of wrestlers
  (except costumes) from Fire Pro Wrestling Returns via ".fpwedit" files
  exported by freem's Fire Pro Wrestling Returns Wrestler Tool. There are many
  caveats related to this feature. Please read the Manual for more information.
(end important feature alert)

* [CPU Logic dialog] Got around to handling Priority Action value -1 (None).

* [Internal] Added Portugal to the CountryNames enum. It was missing before,
  but selectable in the interface...

* [Wrestler Profile dialog] Add Weight Class option, which was missing since
  the beginning and somehow went unnoticed all this time (by not only the
  testers, but myself as well!!).

* [Edit Wrestler] Delete feature now properly handles fixing wrestler display
  order and title holders. (Fixing tournament and league entrant data is not
  handled yet.)

* [Options dialog] Added Wrestler Cache option.
  (Only for save version 3 and above/option chunk version 2 and above.)

* [Options dialog] Opening saves from older game versions now properly removes
  rows from the Options display, instead of leaving blank spaces where future
  options would be.

* [Edit Ring dialog] Import/Export format updated to handle different versions
  of the ring data structure. Ring exports from earlier versions of the program
  will no longer work. Sorry for any troubles this may cause.

* [Referee dialog] Fixed issue where cloning a Referee and then editing
  the clone would change the values of the original referee as well.

* [Edit Wrestler dialog] Added accelerator for wrestler list ('W') and redid
  the tab order of the buttons. For some reason, the text boxes are in the way
  of tab ordering, even when setting their index value to a higher number than
  the remaining items.

* [Wrestler Display Order dialog] Fixed bug where workshop link would still be
  displayed and clickable when switching from a Workshop wrestler to a Preset
  wrestler.

* [Move Names dialog] Enabled in public version.

* [Controls dialog] Select the first controller entry on dialog load.

* [General] Added notification when opening save data from a previous version
  of the game. I should remind you that this program does not provide any sort
  of upgrade path for save files. Please load the save file into the latest
  version of the game before editing the save in this program.

* [Wrestler Display Order dialog] Special case the Retired org/group name.

preview release 2017/09/07 (v1.0.4.0)
=====================================
Note: The original version of the v1.0.4.0 changelog was accidentally deleted,
so there are possibly new features and fixes not listed here.

* General note: Game version 0.9007 did not update the save data structures,
  so no large changes needed to be made to the back-end code. This means
  Save Tool v1.0.3.0 is capable of opening the files, but won't have all the
  following new features and fixes. :)

* Despite Save Tool v1.0.3.0 claiming compatiblity with v0.9006 save data, it
  kept writing back an EditWrestler chunk version number of 1, instead of 2.
  This has been fixed. Apologies for the oversight.

* Workshop dialog changes:
 * Added "Subscription Manager" dialog, which is a fancy name for something
   that lets you remove multiple subscriptions (and optionally, the matching
   local wrestler/referee data) at once.

   IMPORTANT!! THIS DOES NOT TOUCH THE DATA ON THE STEAM SERVERS!
   This is only really useful if you unsubscribed from a bunch of items
   on Steam, but they're still in the game.
 * Deleting local wrestler data in the main Subscription dialog should work,
   now that some progress data failsafes have been put into place.

* Progress data... um, progress.
 * Reading tournament/league progress data works now.
 * Added "Disable Progress Checks" option, which prevents the program from
   yelling at you when deleting a wrestler or referee. (This check should also
   exist for deleting rings and titles as well, but currently does not.)

   ENABLE THIS OPTION IF YOU DO NOT HAVE ANY PROGRESS DATA TO SPEAK OF!
   (It's enabled by default for the time being, and the setting persists
   between program launches.)
 * Created first draft of Progress dialog. Only Tournament information is shown
   in any detail at the moment, and not all values will make sense. Data is
   read-only at this point, so you can't change anything.

* Organizations and Groups dialog changes:
 * Fixed bug (technically an un-coded situation) where you couldn't move a group
   to an empty organization. This should be the final piece of code required for
   dragging and dropping, but please let me know if any issues come up.

* Edit Wrestler main dialog changes:
 * Added "Find..." button/Find Wrestler dialog, which allows you to search for
   a wrestler by text. Particularly useful if you have more edits than you know
   what to do with, and you just want to find someone fast.
   Japanese IME support is recommended for searching with Japanese text.
   Also, since muscle memory is very hard to kill, pressing Control+F brings up
   the Find Wrestler dialog.
 * Wrestler list will now update after you visit the Subscription dialog
   (in case you end up deleting one or more Wrestlers while you're there).

* Edit Wrestler sub-dialog changes:
 * Skills dialog: Custom theme songs (v0.9006 and up) should no longer cause
   issues... I hope. (The code that handles this will need to be updated as
   more default theme songs are added to the game.)
   v0.9005 custom theme support will not be implemented for various reasons.
 * Appearance dialog: Import/Exporting costumes feature implemented.
   This includes being able to selectively pick parts of a costume.

   Warning: I have not fully idiot-proofed the Import portion.

   One known issue is importing multiple costumes into the same costume slot.
   HOWEVER! I can see how this would be useful; e.g. taking the head from one
   costume and the body layers from another costume... so I'm not willing
   to remove it just yet. There should probably be a message if multiple
   conflicting parts are targeted for import to the same costume.

   Another possible issue relates to importing costume slots in
   awkward positions (for example, importing a costume into slot 4 when the
   only previously available slot was the first or second).
   I have not tested how the game handles this.

* Referee dialog changes:
 * Referee list will now update after you visit the Subscription dialog
   (in case you end up deleting one or more Referees while you're there).

* Title dialog changes:
 * Re-arranged items in the dialog.
 * Added S-1 Rules to the match type combo box for save version 1 and above.
 * Added "View Match Options..." button, which doesn't do much right now.

preview release 2017/08/28 (v1.0.3.0)
=====================================
* Public and private versions converged to the same codebase, because
  trying to manage two separate projects is a logistical nightmare.

* Added support for save version 2/game version 0.9006 savedata.

* Updated color dialogs with changes found in the stand-along ring editor.
  (Putting "0-31" or "0-255" in the title when using one of the conversion options.)

* Edit Wrestlers dialog changes:
 * Finished up the code for cloning Edit Wrestlers; enabled the Clone button.
 * Enabled Copy/Paste functionality for CPU Logic.

* Edit Referees dialog changes:
 * Add subscription notification when deleting a Workshop Referee.
 * Fix key accelerators.
 * Clone and Delete options enabled in public version. Delete lacks failsafes.

* Organizations and Groups dialog changes:
 * Enabled resizing the main dialog. (Necessitated by the next change...)
 * Added Workshop item titles to the Member Wrestler list when the specified
   wrestler is a Workshop wrestler.
 * Made the above two changes to the Move Wrestlers dialog as well.

* Workshop dialog changes:
 * Re-organized information on all tabs.
 * Published Item Tags section now uses a ListView.
 * Item Tags now displayed with proper names.
 * Some subscription deletion options have been completed.
   None of these touch the Steam servers, so they're only useful if you've
   unsubscribed from an item outside of the game.
   * Delete local wrestler subscription data (keeps local wrestler data)
   * Delete local referee subscription data (keeps local referee data)
   * Delete local referee subscription data and associated local referee

* Appearance dialog now allows you to change colors.

* Started work on CPU Logic dialog.
  No changes are written back to the save data, so it's essentially read-only.

* Added Local Item ID field to Published Items tab in the Workshop dialog.

* Added Japanese language text for the Language options in the Options dialog.

* Started translating^ some dialogs to Japanese.
 ^ mostly used Google Translate plus insight based on my previous experiences.
 At some point, I'll go back and get the strings the game uses.

* Added Custom Theme Song Filename to Wrestler Skills dialog.
  (Only visible for Save Version 2 and up.)

* Match Options dialog now shows option names. (Values are still index-based.)

* Wrestler Hash dialog changes hash textbox background color if a hash matches
  the default "Build from Blank" model wrestler.

* Started considering implementing support for Tournament/League progress data.
  This is probably required for "proper" deletion of referees and wrestlers.

preview release 2017/08/24 (private v1.0.2.0)
=============================================
* Allow Esc key to close About box.

* Fixed default column width in Move Names dialog.
* Fixed default column width in Match Options dialog.

* Referee dialog changes:
 * Dialog re-structured to be more like the Edit Wrestler dialog.
 * Changing parameters works.
 * Allow renaming referees.
 * Allow deleting referees. (/!\ Does not delete Workshop Subscription Data! /!\)
 * Added Referee Type display. If the referee is a workshop referee,
   a link will appear next to the Referee Type. Clicking this link opens
   the referee in the Workshop dialog.

* Added beginnings of clipboard support.
  Here's what works so far:
  * Wrestler Skills
  * Wrestler Params
  * Wrestler Moveset
  (technically CPU Logic copying/pasting works, but there's no way
  to check the CPU Logic in the program, so I've disabled it for now.)

* Started working on Chunk Browser dialog.
  Performance on certain items (namely Mission, Ring) is bad. Not sure why yet.
  The Chunk Browser is essentially a debugging tool, so I don't care as much,
  but I thought I'd let you know for now.

* Started working on Organizations and Groups dialog.
  Seems to be functioning fine for the following:
  * Changing Long/Short Name
  * Add new Org/Group
  * Delete Org/Group
  * Move Wrestlers
  * Order Org/Group (drag and drop)

  Changing Alignment is untested, but is assumed to work.

* Started working on Wrestler Order dialog.
  Not as much work done here...
  In theory, re-ordering works, but it hasn't been fully tested.

* Made skeleton CPU Logic dialog, but didn't hook it up, as it serves
  no purpose right now. (Coding this screen is always a pain...)

* Added Local ID and Time Stamp to the Workshop dialog's Subscribed
  Wrestler and Referee tabs.

* Title dialog changes:
 * Dialog re-structured to be more like the Edit Wrestler dialog.
 * Added Champion data (Wrestler, Controller, Costume, is Second) to Title dialog.
 * Allow renaming titles, changing strap and plate designs.
 * Allow changing weight class, match type, and participants (without any safety net).
 * Added Title History viewer.

* Wrestler dialog changes:
 * Added Wrestler Type display. If the wrestler is a workshop wrestler, a link
   will appear next to the wrestler type. Clicking this link opens the wrestler
   in the Workshop dialog.

* Update Match Options dialog to have some sort of structure.

* Ring dialog changes:
 * Dialog re-structured to be more like the Edit Wrestler dialog.
 * Rings can now be renamed.
 * Add, Delete, and Import functionality implemented.
 * Fixed color reading order for Pads and Posts.
 * Added Copy/Paste context menu to color panels.
 * Added "Custom Texture Fix" option, which sets the specified color to white.
   Primarily used for Carlzilla's custom ring texture mod, so that textures
   appear as intended.

* Added (internal) Move Name database.

* Fixed bug in Wrestler Profile dialog relating to displayed name order.

preview release 2017/08/10 (v1.0.1.0)
=====================================
* Added Controls dialog.

* Finished adding read support for the Appearance dialog.
  Editing support is still up in the air.

* Added Edit Wrestler dialog.

* Added some Edit Wrestler sub-dialogs:
 * Profile (somewhat functional)
 * Skills (functional)
 * Parameters (functional)
 * Moveset (wip; somewhat functional, not particularly user-friendly)
 * SHA256 Hashes (functional)

* Title dialog now contains Weight Class, Match Type, and Participants.
  Title history still not implemented. Changing items does nothing.

* Referee JSON export test left in by accident.

preview release 2017/08/06 (v1.0.0.0)
=====================================
Initial version. Still very much in progress.
